/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.eip.document;

import java.io.File;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.cayenne.access.DataContext;
import org.apache.cayenne.exp.Expression;
import org.apache.cayenne.exp.ExpressionFactory;
import org.apache.cayenne.query.SelectQuery;
import org.apache.jetspeed.services.logging.JetspeedLogFactoryService;
import org.apache.jetspeed.services.logging.JetspeedLogger;
import org.apache.turbine.util.RunData;
import org.apache.velocity.context.Context;

import com.aimluck.commons.field.ALNumberField;
import com.aimluck.commons.field.ALStringField;
import com.aimluck.eip.document.util.DocumentUtils;
import com.aimluck.eip.cayenne.om.portlet.ImwTDocumentFile;
import com.aimluck.eip.cayenne.om.portlet.ImwTDocumentFileMap;
import com.aimluck.eip.cayenne.om.portlet.ImwTDocumentFolder;
import com.aimluck.eip.cayenne.om.portlet.ImwTDocumentFolderMap;
import com.aimluck.eip.cayenne.om.portlet.EipTMsgboardCategory;
import com.aimluck.eip.cayenne.om.portlet.EipTMsgboardCategoryMap;
import com.aimluck.eip.cayenne.om.portlet.ImwTDocumentRelationMap;
import com.aimluck.eip.cayenne.om.security.TurbineUser;
import com.aimluck.eip.common.ALAbstractFormData;
import com.aimluck.eip.common.ALDBErrorException;
import com.aimluck.eip.common.ALEipConstants;
import com.aimluck.eip.common.ALEipUser;
import com.aimluck.eip.common.ALPageNotFoundException;
import com.aimluck.eip.modules.actions.common.ALAction;
import com.aimluck.eip.orm.DatabaseOrmService;
import com.aimluck.eip.services.accessctl.ALAccessControlConstants;
import com.aimluck.eip.services.eventlog.ALEventlogConstants;
import com.aimluck.eip.services.eventlog.ALEventlogFactoryService;
import com.aimluck.eip.util.ALEipUtils;
import com.aimluck.eip.cayenne.om.portlet.ImwTDocumentFolderMap;
import com.aimluck.eip.cayenne.om.security.TurbineGroup;
import com.aimluck.eip.common.ALEipGroup;
import com.aimluck.eip.document.DocumentFolderSelectData;

/**
 * 文書管理のフォルダフォームデータを管理するクラス <BR>
 *
 */
public class DocumentFolderFormData extends ALAbstractFormData {

  /** logger */
  private static final JetspeedLogger logger = JetspeedLogFactoryService
      .getLogger(DocumentFolderFormData.class.getName());

  /** フォルダ名 */
  private ALStringField folder_name;

  /** 親フォルダ ID */
  private ALNumberField parent_id;

  /** メモ */
  private ALStringField note;

  /** フォルダ情報一覧 */
  private ArrayList folder_hierarchy_list;

  /** 選択されたフォルダ情報 */
  private FolderInfo selected_folderinfo = null;

  /** 親フォルダ情報 */
  private FolderInfo parent_folderinfo = null;

  /** メンバー選択が必要かどうか */
  private boolean is_member;

  /** <code>memberList</code> メンバーリスト */
  private ArrayList memberList;

  /** <code>groups</code> グループ */
  private List groups;

  /** アクセス権限 */
  /** メンバー選択が必要かどうか */
  private boolean is_member_read;
  private boolean is_member_edit;

  /** 閲覧権限メンバーグループリスト */
  private ArrayList memberReadGroupList;
  
  /** 閲覧権限メンバーユーザーリスト */
  private ArrayList memberReadUserList; 
  
  /** 閲覧権限メンバーグループリスト 編集時表示用*/
  private ArrayList readGroupList;
  
  /** 閲覧権限メンバーユーザーリスト 編集時表示用*/
  private ArrayList readUserList;   
  
  /** アクセス権限フラグ */
  private ALNumberField access_flag;

  /** ログインユーザー */
  private ALEipUser login_user;

  private String folderid = null;

  private DataContext dataContext;

  private String org_id;

  /** アクセス制御のフォームを表示するか */
  private boolean show_acl_form = true;

  /**
   *
   * @param action
   * @param rundata
   * @param context
   * @see com.aimluck.eip.common.ALAbstractFormData#init(com.aimluck.eip.modules.actions.common.ALAction,
   *      org.apache.turbine.util.RunData, org.apache.velocity.context.Context)
   */
  public void init(ALAction action, RunData rundata, Context context)
      throws ALPageNotFoundException, ALDBErrorException {

    // 自ポートレットからのリクエストであれば、パラメータを展開しセッションに保存する。
    if (ALEipUtils.isMatch(rundata, context)) {
      // ENTITY ID
      if (rundata.getParameters().containsKey(DocumentUtils.KEY_FOLDER_ID)) {
        ALEipUtils.setTemp(rundata, context, DocumentUtils.KEY_FOLDER_ID,
            rundata.getParameters().getString(DocumentUtils.KEY_FOLDER_ID));
      }
    }

    org_id = DatabaseOrmService.getInstance().getOrgId(rundata);
    dataContext = DatabaseOrmService.getInstance().getDataContext();

    login_user = ALEipUtils.getALEipUser(rundata);

    String tmpfid = ALEipUtils.getTemp(rundata, context,
        DocumentUtils.KEY_FOLDER_ID);
    int fid = DocumentUtils.ROOT_FODLER_ID;
    if (tmpfid != null && !"".equals(tmpfid)) {
      try {
        fid = Integer.parseInt(tmpfid);
      } catch (Exception e) {
        fid = DocumentUtils.ROOT_FODLER_ID;
      }
    } else {
      fid = DocumentUtils.ROOT_FODLER_ID;
    }
    FolderInfo rootFolderInfo = null;
    folder_hierarchy_list = DocumentUtils.getFolderList();
    if (folder_hierarchy_list != null && folder_hierarchy_list.size() > 0) {
      int size = folder_hierarchy_list.size();
      for (int i = 0; i < size; i++) {
        FolderInfo info = (FolderInfo) folder_hierarchy_list.get(i);
        info.setVisible(true);
        if (info.getFolderId() == DocumentUtils.ROOT_FODLER_ID) {
          rootFolderInfo = info;
        }
        if (info.getFolderId() == fid) {
          selected_folderinfo = info;
        }
      }
    }
    DocumentUtils.setFolderVisibleForForm(folder_hierarchy_list, rundata);

    if (selected_folderinfo == null) {
      selected_folderinfo = rootFolderInfo;
    }

    groups = ALEipUtils.getMyGroups(rundata);
    is_member = false;

    super.init(action, rundata, context);
  }

  /*
   * @see com.aimluck.eip.common.ALAbstractFormData#setFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context, java.util.ArrayList)
   */
  protected boolean setFormData(RunData rundata, Context context,
      ArrayList msgList) throws ALPageNotFoundException, ALDBErrorException {

    boolean res = super.setFormData(rundata, context, msgList);

    if (res) {
      if (!rundata.getParameters().containsKey("parent_id")) {
        parent_id.setValue(selected_folderinfo.getFolderId());
      }

      if (ALEipConstants.MODE_UPDATE.equals(getMode())) {
        folderid = ALEipUtils.getTemp(rundata, context,
            DocumentUtils.KEY_FOLDER_ID);
      }

      /* 閲覧メンバー選択が必要か */
      if("checked".equals(rundata.getParameters().get("read_all")))
      {
        is_member_read = false;
      }
      else
      {
        is_member_read = true;
      }
      /* 閲覧権限メンバーリストを画面から取得し、グループとユーザに振り分け */
      if(is_member_read)
      {
        DocumentUtils.separateGroupAndUser(rundata, "member_read", memberReadGroupList, memberReadUserList);
      }
      
      /** メンバーリストの処理 */
      int tmp_access_flag = (int) access_flag.getValue();;
      if (tmp_access_flag == DocumentUtils.ACCESS_PUBLIC_MEMBER
          || tmp_access_flag == DocumentUtils.ACCESS_SECRET_MEMBER) {
        String member[] = rundata.getParameters().getStrings("member_to");
        SelectQuery query = new SelectQuery(TurbineUser.class);
        Expression exp = ExpressionFactory.inExp(
            TurbineUser.LOGIN_NAME_PROPERTY, member);
        query.setQualifier(exp);
        memberList.addAll(ALEipUtils.getUsersFromSelectQuery(query));
        /** ログインユーザが含まれていなかった場合は追加 */
        boolean login_user_exists = false;
        for (int i = 0; i < memberList.size(); i++) {
          if (member[i].equals(login_user.getName())) {
            login_user_exists = true;
            break;
          }
        }
        if (!login_user_exists)
          memberList.add(login_user);
      } else {
        login_user.setName("U" + login_user.getName().getValue());
        memberList.add(login_user);
      }

    }
    return res;
  }

  /**
   * 各フィールドを初期化します。 <BR>
   *
   * @see com.aimluck.eip.common.ALData#initField()
   */
  public void initField() {
    // フォルダ名
    folder_name = new ALStringField();
    folder_name.setFieldName("フォルダ名");
    folder_name.setTrim(true);
    // 親フォルダ
    parent_id = new ALNumberField();
    parent_id.setFieldName("親フォルダ");
    parent_id.setValue(0);
    // メモ
    note = new ALStringField();
    note.setFieldName("メモ");
    note.setTrim(true);
    // アクセス権限フラグ
    access_flag = new ALNumberField();
    access_flag.setFieldName("アクセス権限");
    access_flag.setValue(0);
    // メンバーリスト
    memberList = new ArrayList();
    //閲覧権限メンバーグループリスト
    memberReadGroupList = new ArrayList();
    //閲覧権限メンバーユーザーリスト
    memberReadUserList = new ArrayList();
  }

  /**
   * フォルダの各フィールドに対する制約条件を設定します。 <BR>
   *
   * @see com.aimluck.eip.common.ALAbstractFormData#setValidator()
   */
  protected void setValidator() {
    // フォルダ名必須項目
    folder_name.setNotNull(true);
    // フォルダ名の文字数制限
    folder_name.limitMaxLength(128);
    // 追加位置
    parent_id.limitMinValue(0);
    // メモの文字数制限
    note.limitMaxLength(1000);
    // アクセス権限フラグ
    access_flag.limitValue(0, 3);
  }

  /**
   * フォルダのフォームに入力されたデータの妥当性検証を行います。 <BR>
   *
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#validate(java.util.ArrayList)
   */
  protected boolean validate(ArrayList msgList) {
    // フォルダ名
    folder_name.validate(msgList);
    // 追加位置
    parent_id.validate(msgList);
    // メモ
    note.validate(msgList);
    // アクセス権限フラグ
    access_flag.validate(msgList);
    //フォルダ追加/編集の際、親フォルダにアクセス権限が設定されている場合、エラー出力。
    int tmp_acl_folder = DocumentUtils.getAccessControlFolderId((int) parent_id
        .getValue());
    if (tmp_acl_folder != DocumentUtils.ROOT_FODLER_ID
        && access_flag.getValue() != DocumentUtils.ACCESS_PUBLIC_ALL) {
      msgList.add("上位のフォルダでアクセス権限が設定されています。<br/>このフォルダに対するアクセス権限は設定できません。");
    }

    if (existsFolderName()) {
      msgList.add("このフォルダ名と同じフォルダがすでに存在するため、登録できません。フォルダ名を変更してください。");
    }

    return (msgList.size() == 0);
  }

  private boolean existsFolderName() {
    String fname = folder_name.getValue();
    if (fname == null || "".equals(fname))
      return false;

    try {
      SelectQuery query = new SelectQuery(ImwTDocumentFolder.class);
      if (ALEipConstants.MODE_INSERT.equals(getMode())) {
        Expression exp = ExpressionFactory.matchExp(
            ImwTDocumentFolder.PARENT_ID_PROPERTY, Integer
                .valueOf((int) parent_id.getValue()));
        query.setQualifier(exp);
      } else if (ALEipConstants.MODE_UPDATE.equals(getMode())) {
        Expression exp1 = ExpressionFactory.matchExp(
            ImwTDocumentFolder.PARENT_ID_PROPERTY, Integer
                .valueOf((int) parent_id.getValue()));
        query.setQualifier(exp1);
        Expression exp2 = ExpressionFactory.noMatchDbExp(
            ImwTDocumentFolder.FOLDER_ID_PK_COLUMN, Integer.valueOf(folderid));
        query.andQualifier(exp2);
      }

      List list = dataContext.performQuery(query);
      if (list != null && list.size() > 0) {
        ImwTDocumentFolder tmpfolder = null;
        int size = list.size();
        for (int i = 0; i < size; i++) {
          tmpfolder = (ImwTDocumentFolder) list.get(i);
          if (fname.equals(tmpfolder.getFolderName())) {
            return true;
          }
        }
      }
    } catch (Exception e) {
      return true;
    }

    return false;
  }

  /**
   * フォルダをデータベースから読み出します。 <BR>
   *
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#loadFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context)
   */
  protected boolean loadFormData(RunData rundata, Context context,
      ArrayList msgList) {
    try {
      // オブジェクトモデルを取得
      ImwTDocumentFolder folder = DocumentUtils.getImwTDocumentFolder(rundata,
          context);
      if (folder == null)
        return false;

      // フォルダ名
      folder_name.setValue(folder.getFolderName());
      // メモ
      note.setValue(folder.getNote());
      // アクセス権限
      access_flag.setValue(folder.getPublicFlag());
      
      //閲覧権限メンバーグループリスト
      readGroupList = new ArrayList();
      //閲覧権限メンバーユーザーリスト
      readUserList = new ArrayList();
      
      is_member = true;
      //共有フォルダでは、PublicFlag(アクセス種類)をaccess_flag(アクセス権限)で判断してグループ、ユーザーのリストを作成していたが、
      //文書管理のフォルダは、システム管理者以外は閲覧権限しかないため、if条件を削除。
      
      // グループのリストを取得
      SelectQuery gmapquery = new SelectQuery(ImwTDocumentFolderMap.class);
      Expression gmapexp = ExpressionFactory.matchDbExp(
          ImwTDocumentFolderMap.IMW_TDOCUMENT_FOLDER_PROPERTY, folder.getFolderId());
      gmapquery.setQualifier(gmapexp);
      List glist = dataContext.performQuery(gmapquery);

      List group = new ArrayList();
      int gsize = glist.size();
      for (int i = 0; i < gsize; i++) {
        ImwTDocumentFolderMap map = (ImwTDocumentFolderMap) glist.get(i);
        Integer gid = map.getGroupId();
        if (gid != null) {
          //全ユーザーが閲覧可能な場合
          if(gid.intValue() == -1){
            is_member = false;
            break;
          }
          group.add(map.getGroupId());
        }
      }
      SelectQuery gquery = new SelectQuery(TurbineGroup.class);
      Expression gexp = ExpressionFactory.inDbExp(
          TurbineGroup.GROUP_ID_PK_COLUMN, group);
      gquery.setQualifier(gexp);
      readGroupList.addAll(DocumentFolderSelectData.getGroupFromSelectQuery(gquery));
      
      
      
      
      // メンバーのリストを取得
      SelectQuery mapquery = new SelectQuery(ImwTDocumentFolderMap.class);
      Expression mapexp = ExpressionFactory.matchDbExp(
          ImwTDocumentFolderMap.IMW_TDOCUMENT_FOLDER_PROPERTY, folder.getFolderId());
      mapquery.setQualifier(mapexp);
      List list = dataContext.performQuery(mapquery);

      List users = new ArrayList();
      int usize = list.size();
      for (int i = 0; i < usize; i++) {
        ImwTDocumentFolderMap map = (ImwTDocumentFolderMap) list.get(i);
        users.add(map.getUserId());
      }
      SelectQuery query = new SelectQuery(TurbineUser.class);
      Expression exp = ExpressionFactory.inDbExp(
          TurbineUser.USER_ID_PK_COLUMN, users);
      query.setQualifier(exp);
      readUserList.addAll(DocumentFolderSelectData.getUsersFromSelectQuery(query));

      // フォルダ階層の表示切替
      int folder_id = selected_folderinfo.getFolderId();
      ArrayList disable_list = new ArrayList();
      disable_list.add(Integer.valueOf(folder_id));
      int size = folder_hierarchy_list.size();
      for (int i = 0; i < size; i++) {
        FolderInfo info = (FolderInfo) folder_hierarchy_list.get(i);
        boolean flg = false;
        int len = disable_list.size();
        for (int j = 0; j < len; j++) {
          Integer id = (Integer) disable_list.get(j);
          if (info.getFolderId() == id.intValue()
              || info.getParentFolderId() == id.intValue()) {
            flg = true;
            break;
          }
        }
        if (flg) {
          info.setVisible(false);
          disable_list.add(Integer.valueOf(info.getFolderId()));
        } else {
          info.setVisible(true);
        }
      }

      DocumentUtils.setFolderVisibleForForm(folder_hierarchy_list, rundata);

      for (int i = 0; i < size; i++) {
        FolderInfo info = (FolderInfo) folder_hierarchy_list.get(i);
        if (info.getFolderId() == selected_folderinfo.getParentFolderId()) {
          // 現在編集中のフォルダの親フォルダを選択させる．
          selected_folderinfo = info;
        }
      }

      /** アクセス権限のフォームを表示するか */
      if (Integer.valueOf(folder.getPublicFlag()) == DocumentUtils.ACCESS_PUBLIC_ALL) {
        int acl_folder = DocumentUtils.getAccessControlFolderId(folder
            .getParentId());
        if (acl_folder == 1)
          /** 上位フォルダをルートフォルダまで探しても、アクセス制限されているフォルダが発見されなかった */
          show_acl_form = true;
        else
          /** 上位フォルダでアクセス制限されている */
          show_acl_form = false;
      } else {
        /** このフォルダーにアクセス権限が設定されているので、フォームを表示する */
        show_acl_form = true;
      }

    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
    return true;
  }

  /**
   * フォルダをデータベースとファイルシステムから削除します。 <BR>
   *
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#deleteFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context)
   */
  protected boolean deleteFormData(RunData rundata, Context context,
      ArrayList msgList) {
    try {
      String folderid = ALEipUtils.getTemp(rundata, context,
          DocumentUtils.KEY_FOLDER_ID);
      int delete_id = Integer.parseInt(folderid);
      if (delete_id <= DocumentUtils.ROOT_FODLER_ID) {
        // フォルダ『ルートフォルダ』は削除不可にする．
        return false;
      }
      int delete_parent_id = 0;

      // フォルダ情報を取得する．
      SelectQuery query = new SelectQuery(ImwTDocumentFolder.class);
      Expression exp1 = ExpressionFactory.matchDbExp(
          ImwTDocumentFolder.FOLDER_ID_PK_COLUMN, Integer.valueOf(folderid));
      Expression exp2 = ExpressionFactory.matchExp(
          ImwTDocumentFolder.PARENT_ID_PROPERTY, Integer.valueOf(folderid));
      query.setQualifier(exp1.orExp(exp2));
      List list = dataContext.performQuery(query);
      if (list == null || list.size() <= 0) {
        return false;
      }

      ArrayList folderids = new ArrayList();
      ImwTDocumentFolder folder = null;
      int size = list.size();
      for (int i = 0; i < size; i++) {
        folder = (ImwTDocumentFolder) list.get(i);
        folderids.add(folder.getFolderId());
        if (folder.getFolderId().intValue() == delete_id) {
          delete_parent_id = folder.getParentId().intValue();
        }
      }

      // データベースのフォルダ情報を削除する．
      SelectQuery delfolderquery = new SelectQuery(ImwTDocumentFolder.class);
      Expression delfolderexp = ExpressionFactory.inDbExp(
          ImwTDocumentFolder.FOLDER_ID_PK_COLUMN, folderids);
      delfolderquery.setQualifier(delfolderexp);
      List delFolderList = dataContext.performQuery(delfolderquery);

      int delFolderListsize = delFolderList.size();

      // フォルダ情報を削除
      for (int i = 0; i < delFolderListsize; i++) {
        ImwTDocumentFolder delfolder = (ImwTDocumentFolder) delFolderList.get(i);

        // entityIdを取得
        Integer entityId = delfolder.getFolderId();
        // フォルダ名を取得
        String folderName = delfolder.getFolderName();

        // List documentfiles = delfolder.getImwTDocumentFiles();
        List documentfiles = DocumentUtils.getImwTDocumentFileList(delfolder
            .getFolderId().intValue());
        ArrayList fpaths = new ArrayList();
        ArrayList fdocids = new ArrayList();
        if ((documentfiles != null) && (documentfiles.size() > 0)) {
          int tsize = documentfiles.size();
          for (int k = 0; k < tsize; k++) {
            fpaths.add(((ImwTDocumentFile) documentfiles.get(k)).getFilePath());
            fdocids.add(((ImwTDocumentFile) documentfiles.get(k)).getDocId());
          }
        }
        List listFileMap = new ArrayList();
        List listFileRelationMap = new ArrayList();
        List listFileRelationPath = new ArrayList();
        if (fdocids != null && fdocids.size() > 0) {
          //文書ファイルマップ削除
          Expression expressionFileMap = ExpressionFactory.inExp(ImwTDocumentFileMap.DOC_ID_PROPERTY, fdocids);
          SelectQuery queryFileMap = new SelectQuery(ImwTDocumentFileMap.class);
          queryFileMap.setQualifier(expressionFileMap);
          listFileMap = dataContext.performQuery(queryFileMap);
          dataContext.deleteObjects(listFileMap);
          
          //文書ファイル関連マップ削除
          Expression expressionRelationMap = ExpressionFactory.inExp(ImwTDocumentRelationMap.DOC_ID_PROPERTY, fdocids);
          SelectQuery queryRelationMap = new SelectQuery(ImwTDocumentRelationMap.class);
          queryRelationMap.setQualifier(expressionRelationMap);
          listFileRelationMap = dataContext.performQuery(queryRelationMap);
          if (listFileRelationMap != null && listFileRelationMap.size() > 0) {
            //関連文書ファイルパスの配列を作成
            for (int j=0; j < listFileRelationMap.size(); j++) {
              listFileRelationPath.add(((ImwTDocumentRelationMap) listFileRelationMap.get(j)).getFilePath());
            }
          }
          dataContext.deleteObjects(listFileRelationMap);
        }

        // フォルダ & ファイル情報を削除
        dataContext.deleteObject(delfolder);
        dataContext.commitChanges();

        // ログに保存
        ALEventlogFactoryService.getInstance().getEventlogHandler().log(
            entityId, ALEventlogConstants.PORTLET_TYPE_DOCUMENT_FOLDER,
            folderName);

        if (fpaths.size() > 0) {
          // ローカルファイルに保存されているファイルを削除する．
          File file = null;
          int fsize = fpaths.size();
          for (int k = 0; k < fsize; k++) {
            file = new File(DocumentUtils.getSaveDirPath(org_id)
                + (String) fpaths.get(k));
            if (file.exists()) {
              file.delete();
            }
          }
        }
        if (listFileRelationPath != null && listFileRelationPath.size() > 0) {
          for (int l=0; l < listFileRelationPath.size(); l++) {
            // ローカルファイルに保存されている関連文書を削除する．
            File local_file = null;
            local_file = new File(DocumentUtils.getSaveDirPath(org_id)
                + listFileRelationPath.get(l).toString());
            if (local_file.exists()) {
              local_file.delete();
            }
          }
        }
      }

      // 論理フォルダ階層をリロードする．
      folder_hierarchy_list = DocumentUtils.getFolderList();
      DocumentUtils.setFolderVisibleForForm(folder_hierarchy_list, rundata);
      selected_folderinfo = DocumentUtils.getSelectedFolderInfo(
          folder_hierarchy_list, delete_parent_id);
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
    return true;
  }

  /**
   * フォルダをデータベースとファイルシステムに格納します。 <BR>
   *
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗
   * @see com.aimluck.eip.common.ALAbstractFormData#insertFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context, java.util.ArrayList)
   */
  protected boolean insertFormData(RunData rundata, Context context,
      ArrayList msgList) {
    boolean res = false;
    try {
      int uid = ALEipUtils.getUserId(rundata);

      // 新規オブジェクトモデル
      ImwTDocumentFolder folder = (ImwTDocumentFolder) dataContext
          .createAndRegisterNewObject(ImwTDocumentFolder.class);
      // 親フォルダ ID
      folder.setParentId(Integer.valueOf((int) parent_id.getValue()));
      // フォルダ名
      folder.setFolderName(folder_name.getValue());
      // メモ
      folder.setNote(note.getValue());
      // 作成者
      folder.setCreateUserId(Integer.valueOf(uid));
      // 更新者
      folder.setUpdateUserId(Integer.valueOf(uid));
      // 作成日
      folder.setCreateDate(Calendar.getInstance().getTime());
      // 更新日
      folder.setUpdateDate(Calendar.getInstance().getTime());

      // 閲覧権限
      if (is_member_read)
      {
        insertFolderMap(memberReadGroupList,memberReadUserList,folder);
      }
      else
      {
        insertFolderMapAllUser(folder);
      }
      // アクセス権限
      //int accessFlag = (int) access_flag.getValue();
      int accessFlag = 0;
      folder.setPublicFlag(String.valueOf(accessFlag));

/*      for (int i = 0; i < memberList.size(); i++) {
        ImwTDocumentFolderMap map = (ImwTDocumentFolderMap) dataContext
            .createAndRegisterNewObject(ImwTDocumentFolderMap.class);
        ALEipUser user = (ALEipUser) memberList.get(i);
        int user_id = (int) user.getUserId().getValue();

        map.setImwTDocumentFolder(folder);
        map.setUserId(Integer.valueOf(user_id));
      }
*/
      // フォルダを登録
      dataContext.commitChanges();

      // イベントログに保存
      ALEventlogFactoryService.getInstance().getEventlogHandler().log(
          folder.getFolderId(),
          ALEventlogConstants.PORTLET_TYPE_DOCUMENT_FOLDER,
          folder_name.getValue());

      int size = folder_hierarchy_list.size();
      for (int i = 0; i < size; i++) {
        FolderInfo info = (FolderInfo) folder_hierarchy_list.get(i);
        if (info.getFolderId() == parent_id.getValue()) {
          parent_folderinfo = info;
          break;
        }
      }

      selected_folderinfo.setFolderId(folder.getFolderId().intValue());
      selected_folderinfo.setFolderName(folder.getFolderName());
      selected_folderinfo.setHierarchyIndex(parent_folderinfo
          .getHierarchyIndex() + 1);
      selected_folderinfo.setParentFolderId(parent_folderinfo.getFolderId());

      res = true;
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
    return res;
  }

  /**
   * グループリストとユーザリストをIMW_T_DOCUMENT_FILE_MAPテーブルに挿入します。 <BR>
   *
   */
  protected boolean insertFolderMap
  (
      ArrayList groupList, ArrayList userList,
      ImwTDocumentFolder folder
  )
  {
    try{
    //アクセス権限　ユーザ
      for (int i = 0; i < userList.size(); i++) {
        ImwTDocumentFolderMap map = (ImwTDocumentFolderMap) dataContext
            .createAndRegisterNewObject(ImwTDocumentFolderMap.class);
        ALEipUser user = (ALEipUser) userList.get(i);
        int user_id = (int) user.getUserId().getValue();
  
        //map.setImwTDocumentFile(file);
        map.setUserId(Integer.valueOf(user_id));
        map.setImwTDocumentFolder(folder);
      }
      
      //アクセス権限　グループ
      for (int i = 0; i < groupList.size(); i++) {
        ImwTDocumentFolderMap map = (ImwTDocumentFolderMap) dataContext
            .createAndRegisterNewObject(ImwTDocumentFolderMap.class);
        TurbineGroup group = (TurbineGroup) groupList.get(i);
        String group_id = (String) group.getId();
  
        //map.setImwTDocumentFile(file);
        map.setGroupId(Integer.valueOf(group_id));
        map.setImwTDocumentFolder(folder);
      }
      
      
      return true;
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
  }
  
  /**
   * 全てのユーザを示す値をIMW_T_DOCUMENT_FILE_MAPテーブルに挿入します。 <BR>
   *
   */
  protected boolean insertFolderMapAllUser
  (
      ImwTDocumentFolder folder
  )
  {
    try{
      ImwTDocumentFolderMap map = (ImwTDocumentFolderMap) dataContext
      .createAndRegisterNewObject(ImwTDocumentFolderMap.class);
      map.setGroupId(Integer.valueOf(-1));
      map.setImwTDocumentFolder(folder);
      return true;
    } catch (Exception ex) {
      logger.error("Exception", ex);
      return false;
    }
  }

  /**
   * データベースとファイルシステムに格納されているフォルダを更新します。 <BR>
   *
   * @param rundata
   * @param context
   * @param msgList
   * @return TRUE 成功 FALSE 失敗O
   * @see com.aimluck.eip.common.ALAbstractFormData#updateFormData(org.apache.turbine.util.RunData,
   *      org.apache.velocity.context.Context, java.util.ArrayList)
   */
  protected boolean updateFormData(RunData rundata, Context context,
      ArrayList msgList) {
    try {
      // オブジェクトモデルを取得
      ImwTDocumentFolder folder = DocumentUtils.getImwTDocumentFolder(rundata,
          context);
      if (folder == null)
        return false;

      int uid = ALEipUtils.getUserId(rundata);

      // フォルダ名
      folder.setFolderName(folder_name.getValue());
      // 親フォルダ ID
      folder.setParentId(Integer.valueOf((int) parent_id.getValue()));
      // メモ
      folder.setNote(note.getValue());
      // 更新者
      folder.setUpdateUserId(Integer.valueOf(uid));
      // 更新日
      folder.setUpdateDate(Calendar.getInstance().getTime());

      // アクセス権限
      // 一度、既存のマップを全て削除する
      SelectQuery mapquery = new SelectQuery(ImwTDocumentFolderMap.class);
      Expression mapexp = ExpressionFactory.matchExp(
          ImwTDocumentFolderMap.IMW_TDOCUMENT_FOLDER_PROPERTY, folder
              .getFolderId());
      mapquery.setQualifier(mapexp);
      List maplist = dataContext.performQuery(mapquery);
      dataContext.deleteObjects(maplist);


      // マップを登録しなおす
      
      // 閲覧権限
      if (is_member_read)
      {
        insertFolderMap(memberReadGroupList,memberReadUserList,folder);
      }
      else
      {
        insertFolderMapAllUser(folder);
      }

      int accessFlag = 0;
      folder.setPublicFlag(String.valueOf(accessFlag));

// 新規追加時、作成者を2重に登録する為、削除
/*      for (int i = 0; i < memberList.size(); i++) {
        ImwTDocumentFolderMap map = (ImwTDocumentFolderMap) dataContext
            .createAndRegisterNewObject(ImwTDocumentFolderMap.class);
        ALEipUser user = (ALEipUser) memberList.get(i);
        int user_id = (int) user.getUserId().getValue();

        map.setImwTDocumentFolder(folder);
        map.setUserId(Integer.valueOf(user_id));
      }
*/
      if (accessFlag != DocumentUtils.ACCESS_PUBLIC_ALL) {
        /** 子フォルダのアクセス権限を全てACCESS_PUBLIC_ALLに設定 */
        List children = DocumentUtils.getChildFolders(folder);
        for (int i = 0; i < children.size(); i++) {
          ImwTDocumentFolder child = (ImwTDocumentFolder) children.get(i);
          child.setPublicFlag(String.valueOf(DocumentUtils.ACCESS_PUBLIC_ALL));
        }
      }

      // フォルダを更新
      dataContext.commitChanges();

      // イベントログに保存
      ALEventlogFactoryService.getInstance().getEventlogHandler().log(
          folder.getFolderId(),
          ALEventlogConstants.PORTLET_TYPE_DOCUMENT_FOLDER,
          folder_name.getValue());
    } catch (Exception ex) {
      dataContext.rollbackChanges();
      logger.error("Exception", ex);
      return false;
    }
    return true;
  }

  /**
   * フォルダ名を取得する． <BR>
   *
   * @return
   */
  public ALStringField getFolderName() {
    return folder_name;
  }

  public ALNumberField getParentId() {
    return parent_id;
  }

  public ALNumberField getAccessFlag() {
    return access_flag;
  }

  public List getGroupList() {
    return groups;
  }

  public boolean isMember() {
    return (is_member && memberList.size() > 0);
  }

  /**
   * グループメンバーを取得します。
   *
   * @return
   */
  public List getMemberList() {
    return memberList;
  }

  /**
   * 編集表示用グループメンバーを取得します。
   *
   * @return
   */
  public List getReadGroupList() {
    return readGroupList;
  }
  /**
   * 編集表示用グループメンバーを取得します。
   *
   * @return
   */
  public List getReadUserList() {
    return readUserList;
  }
  public boolean getReadMember() {
    return (is_member);
  }
  
  /**
   * メモを取得する． <BR>
   *
   * @return
   */
  public ALStringField getNote() {
    return note;
  }

  public ArrayList getFolderHierarchyList() {
    return folder_hierarchy_list;
  }

  public FolderInfo getSelectedFolderInfo() {
    return selected_folderinfo;
  }

  public boolean showAclForm() {
    return show_acl_form;
  }

  /**
   *
   * @param id
   * @return
   */
  public boolean isMatch(int id1, long id2) {
    return id1 == (int) id2;
  }

  /**
   * アクセス権限チェック用メソッド。<br />
   * アクセス権限の機能名を返します。
   *
   * @return
   */
  public String getAclPortletFeature() {
    return ALAccessControlConstants.POERTLET_FEATURE_DOCUMENT_FOLDER;
  }
}
